<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 9/11/2016
 * Time: 7:23 PM
 */

namespace Fr\RetailMeNot\Cloud\StateMachine;

class StateMachineException extends \Exception {

    const ENVIRONMENTAL_PROPERTY_NOT_FOUND = 1;
    const ENVIRONMENT_NOT_DEFINED = 2;
    const CURRENT_STEP_NOT_DEFINED = 3;
    const CURRENT_STEP_NOT_FOUND = 4;

    public function __construct($code, $complement = '') {

        switch($code) {
            case self::ENVIRONMENTAL_PROPERTY_NOT_FOUND : $message = "Property not define into environment"; break;
            case self::ENVIRONMENT_NOT_DEFINED : $message = "State Machine environment not define into state"; break;
            case self::CURRENT_STEP_NOT_DEFINED : $message = "Current step not defined"; break;
            case self::CURRENT_STEP_NOT_FOUND : $message = "Current step not found"; break;
            default: $message = "Unknown error";
        }

        parent::__construct($message, $code);
    }

}
